# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rosbag_snapshot_msgs/SnapshotStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import rosgraph_msgs.msg

class SnapshotStatus(genpy.Message):
  _md5sum = "da7b0d829f1bb54c3d787d81f6befe0f"
  _type = "rosbag_snapshot_msgs/SnapshotStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Describes the current status of a running 'rosbag_snapshot' node

# Information about the buffer of subscribed topics
# The period, stamp, node_pub, and dropped_msgs fields are left empty
rosgraph_msgs/TopicStatistics[] topics
# If true, new messages are being added to the snapshot buffers
# If false, snapshotter is currently paused or writing to a bag file
bool enabled

================================================================================
MSG: rosgraph_msgs/TopicStatistics
# name of the topic
string topic

# node id of the publisher
string node_pub

# node id of the subscriber
string node_sub

# the statistics apply to this time window
time window_start
time window_stop

# number of messages delivered during the window
int32 delivered_msgs
# numbers of messages dropped during the window
int32 dropped_msgs

# traffic during the window, in bytes
int32 traffic

# mean/stddev/max period between two messages
duration period_mean
duration period_stddev
duration period_max

# mean/stddev/max age of the message based on the
# timestamp in the message header. In case the
# message does not have a header, it will be 0.
duration stamp_age_mean
duration stamp_age_stddev
duration stamp_age_max
"""
  __slots__ = ['topics','enabled']
  _slot_types = ['rosgraph_msgs/TopicStatistics[]','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       topics,enabled

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SnapshotStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.topics is None:
        self.topics = []
      if self.enabled is None:
        self.enabled = False
    else:
      self.topics = []
      self.enabled = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.topics)
      buff.write(_struct_I.pack(length))
      for val1 in self.topics:
        _x = val1.topic
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.node_pub
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.node_sub
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v1 = val1.window_start
        _x = _v1
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _v2 = val1.window_stop
        _x = _v2
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(_get_struct_3i().pack(_x.delivered_msgs, _x.dropped_msgs, _x.traffic))
        _v3 = val1.period_mean
        _x = _v3
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _v4 = val1.period_stddev
        _x = _v4
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _v5 = val1.period_max
        _x = _v5
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _v6 = val1.stamp_age_mean
        _x = _v6
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _v7 = val1.stamp_age_stddev
        _x = _v7
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _v8 = val1.stamp_age_max
        _x = _v8
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
      _x = self.enabled
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.topics is None:
        self.topics = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.topics = []
      for i in range(0, length):
        val1 = rosgraph_msgs.msg.TopicStatistics()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.topic = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.topic = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.node_pub = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.node_pub = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.node_sub = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.node_sub = str[start:end]
        _v9 = val1.window_start
        _x = _v9
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        _v10 = val1.window_stop
        _x = _v10
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        _x = val1
        start = end
        end += 12
        (_x.delivered_msgs, _x.dropped_msgs, _x.traffic,) = _get_struct_3i().unpack(str[start:end])
        _v11 = val1.period_mean
        _x = _v11
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        _v12 = val1.period_stddev
        _x = _v12
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        _v13 = val1.period_max
        _x = _v13
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        _v14 = val1.stamp_age_mean
        _x = _v14
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        _v15 = val1.stamp_age_stddev
        _x = _v15
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        _v16 = val1.stamp_age_max
        _x = _v16
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        self.topics.append(val1)
      start = end
      end += 1
      (self.enabled,) = _get_struct_B().unpack(str[start:end])
      self.enabled = bool(self.enabled)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.topics)
      buff.write(_struct_I.pack(length))
      for val1 in self.topics:
        _x = val1.topic
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.node_pub
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.node_sub
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v17 = val1.window_start
        _x = _v17
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _v18 = val1.window_stop
        _x = _v18
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(_get_struct_3i().pack(_x.delivered_msgs, _x.dropped_msgs, _x.traffic))
        _v19 = val1.period_mean
        _x = _v19
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _v20 = val1.period_stddev
        _x = _v20
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _v21 = val1.period_max
        _x = _v21
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _v22 = val1.stamp_age_mean
        _x = _v22
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _v23 = val1.stamp_age_stddev
        _x = _v23
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _v24 = val1.stamp_age_max
        _x = _v24
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
      _x = self.enabled
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.topics is None:
        self.topics = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.topics = []
      for i in range(0, length):
        val1 = rosgraph_msgs.msg.TopicStatistics()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.topic = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.topic = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.node_pub = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.node_pub = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.node_sub = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.node_sub = str[start:end]
        _v25 = val1.window_start
        _x = _v25
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        _v26 = val1.window_stop
        _x = _v26
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        _x = val1
        start = end
        end += 12
        (_x.delivered_msgs, _x.dropped_msgs, _x.traffic,) = _get_struct_3i().unpack(str[start:end])
        _v27 = val1.period_mean
        _x = _v27
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        _v28 = val1.period_stddev
        _x = _v28
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        _v29 = val1.period_max
        _x = _v29
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        _v30 = val1.stamp_age_mean
        _x = _v30
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        _v31 = val1.stamp_age_stddev
        _x = _v31
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        _v32 = val1.stamp_age_max
        _x = _v32
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        self.topics.append(val1)
      start = end
      end += 1
      (self.enabled,) = _get_struct_B().unpack(str[start:end])
      self.enabled = bool(self.enabled)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_2i = None
def _get_struct_2i():
    global _struct_2i
    if _struct_2i is None:
        _struct_2i = struct.Struct("<2i")
    return _struct_2i
_struct_3i = None
def _get_struct_3i():
    global _struct_3i
    if _struct_3i is None:
        _struct_3i = struct.Struct("<3i")
    return _struct_3i
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
